using System;

namespace Lazy.Example
{

	public struct Point {
		public float x;
		public float y;

		public Point (float x, float y) {
			this.x = x;
			this.y = y;
		}
	}


	public class Rectangle {
		float xmin;
		float xmax;
		float ymin;
		float ymax;

		public Rectangle (float xmin, float xmax, float ymin, float ymax) {
			this.xmin = xmin;
			this.xmax = xmax;
			this.ymin = ymin;
			this.ymax = ymax;
		}

		public float GetArea () {
			return (xmax-xmin)*(ymax-ymin);
		}
	}

	public class Polygon {
		Point[] vertices;

		public Polygon (Point[] vertices) {
			this.vertices = vertices;
		}

		public float GetArea () {

			// http://mathworld.wolfram.com/PolygonArea.html

			int i;
			int n = 0;
			float area = 0;
			
			if (vertices!=null) 
				n = vertices.Length;

			for (i=0; i<n; i++) {
				area += vertices[i].x*vertices[(i+1)%n].y 
					- vertices[i].y*vertices[(i+1)%n].x;
			}

			area = Math.Abs(area)/2;

			return area;
		}
	}

}
