using System;

namespace Lazy.Example
{
	/// <summary>
	/// Descripcin breve de Class1.
	/// </summary>
	// Usage
	
	public class LazyLotTest {

		public static void Test () {

			LazyObjectModel model = new LazyObjectModel(typeof(LotImplementation));


			Lot lot = (Lot) LazyFactory.Create(typeof(Lot));
			Lot lot2 = (Lot) LazyFactory.Create(typeof(Lot));

			// Prueba el constructor del tipo lazy (MODEL_FIELD debe ser pblico)

			model = (LazyObjectModel) lot.GetType().GetField(LazyType.MODEL_FIELD).GetValue(lot);

			Console.Out.WriteLine("LAZY OBJECT MODEL");
			Console.Out.WriteLine();
			Console.Out.WriteLine(model);
			Console.Out.WriteLine();


			Console.Out.WriteLine();
			Console.Out.WriteLine("LAZY OBJECT EVOLUTION");
			Console.Out.WriteLine();

			lot.Area = 10;
			ShowLot(lot);
			ShowArea(lot,model);
			
			lot.MBR = new Rectangle(1,4,1,4);
			ShowLot(lot);
			ShowArea(lot,model);
			
			lot.Area = 0;
			ShowLot(lot);
			ShowArea(lot,model);

			lot.Photograph = new Image();
			ShowLot(lot);
			ShowArea(lot,model);

			lot.Perimeter = new Polygon( new Point[]{ new Point(0,0), new Point(2,0), new Point (0,2)} );
			ShowLot(lot);
			ShowArea(lot,model);

			lot.MBR = null;
			ShowLot(lot);
			ShowArea(lot,model);

			lot.Area = 10.5f;
			ShowLot(lot);
			ShowArea(lot,model);


			LotSubclass subclass = new LotSubclass();

			Console.WriteLine("SUBCLASS "+subclass.Area);


			Console.In.ReadLine();
		}

		private static float GetArea (LazyObjectModel model, Lot lot) {
			Console.Write("["+model.LazyMethod(lot,0).Method+"] ");
			return (float) model.InvokeMethod(lot,0, new object[]{});
		}


		private static void ShowLot (Lot lot) {

			Console.Out.WriteLine();
			Console.Out.WriteLine("Lot: "+lot);
			//Console.Out.WriteLine("Lot area: "+lot.GetArea());
			Console.Out.WriteLine("- Area "+ ((LotImplementation)lot).GetArea());
			Console.Out.WriteLine("- MBR "+ ((LotImplementation)lot).GetAreaFromMBR());
			Console.Out.WriteLine("- Perimeter "+ ((LotImplementation)lot).GetAreaFromPerimeter());
		}

		private static void ShowArea (Lot lot, LazyObjectModel model) {

			float actualArea = lot.GetArea();
			float lazyArea = GetArea(model,lot);

            Console.WriteLine("LAZY Area = "+ actualArea + " vs. " + lazyArea );
		}

		[STAThread]
		static void Main(string[] args) {

			Test();
		 
		}


	}
}
