using System;
using System.Reflection;

namespace Lazy
{
	/// <summary>
	/// Descripcin breve de Class1.
	/// </summary>
	/// 	
	
	[AttributeUsage(AttributeTargets.Method)]
	public class AlternativeImplementationAttribute : Attribute {

		private string method;
		private Type[] parameters;

		public AlternativeImplementationAttribute (string method)
			: this(method, null)
		{
		}

		public AlternativeImplementationAttribute (string method, Type[] parameters) {
			this.method = method;
			this.parameters = parameters;
		}

		public string Method {
			get { return method; }
		}

		public Type[] Parameters {
			get { return parameters; }
		}
	}
}
