using System;
using System.Collections;
using System.Reflection;

namespace Lazy
{
	/// <summary>
	/// Descripcin breve de LazyFieldModel.
	/// </summary>
	public class LazyFieldModel
	{
		private LazyObjectModel model;
		private FieldInfo field;

		private SortedList used;     // Method signature -> LazyMethodModel
		private SortedList defined;  // Method signature -> LazyMethodModel

		public LazyFieldModel (LazyObjectModel model, FieldInfo field)
		{
			this.model = model;
			this.field = field;

			this.used = new SortedList();
			this.defined = new SortedList(); 
		}

		// Accessor

		
		public FieldInfo Field {
			get { return field; }
		}

		// Salida estndar

		public override string ToString () {

			return field.ToString();
		}

		// Uses and definitions

		public SortedList Used {
			get { return used; }
		}

		public SortedList Defined {
			get { return defined; }
		}


		public void DefinedIn (LazyMethodModel method) {
			defined.Add(method.Method, method);
		}

		public void UsedIn (LazyMethodModel method) {
			used.Add(method.Method, method);
		}
	}
}
