using System;

namespace Lazy.Test
{

	[Lazy]
	class LazyClass {

		private int privateField;
		protected int protectedField;
		internal int internalField;
		public int publicField;

		// Alternative implementation 

		public void Method () {}

		[AlternativeImplementation("Method")]
		public void MethodAlternative () {}

		// Alternative implementation with return type

		public int Method2 () { return 0; }

		[AlternativeImplementation("Method2")]
		public int Method2Alternative () { return 0; }

		// Alternative implementation with parameters

		public void Method3 (int x, int y) { }

		[AlternativeImplementation("Method3")]
		public void Method3Alternative (int x, int y) {}

		// Alternative implementation with overload

		public void Method4 (int x, int y) { }
		public void Method4 (int x, int y, int z) { }

		[AlternativeImplementation("Method4")]
		public void Method4Alternative (int x, int y, int z) {}


	}
}
