using System;

namespace EmitTest
{
	/// <summary>
	/// Descripcin breve de BaseClass.
	/// </summary>
	public class BaseClass
	{
		private   int x;		
		protected int y;
		protected int z;
		public    string str;

		public BaseClass (int x, int y, int z, string str) {
			this.x = x;
			this.y = y;
			this.z = z;
			this.str = str;
		}

		public override string ToString() {
			return x + " " + y + " " + z + " " + str;
		}

		public virtual void Set (int n) {
			SetX(n);
		}

		public void SetX (int n) {
			x = n;
		}

		public void SetY (int n) {
			y = n;
		}

	}

	public class SubClass: BaseClass {

		public SubClass (int x, int y, int z): base(x,y,z,"Sub") {
			
		}

		public override void Set (int n) {
			base.SetY(n);
		}

		public void Copy () {
			z = y;
		}

		public void TestHierarchy (int n) {

			base.Set(n);
		}

		public void TestReflection () {
			object[] parameters = new object[]{2};
			
			GetMethod().Invoke(this,parameters);
		}

		private System.Reflection.MethodInfo GetMethod () {
			Type[] parameterTypes = new Type[]{ typeof(int) };

			return this.GetType().GetMethod("Set", parameterTypes);
		}

		public bool TestIf (string methodName1, string methodName2) {

			if (methodName1 == methodName2) {
				return true;
			} else {
				return false;
			}
		}

	}
}
