using System;

namespace ILDASMTest
{
	/// <summary>
	/// Descripcin breve de Class1.
	/// </summary>
	public class Test
	{
		int field;


		public Test (int x)
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
			field = x;
		}

		public int TestIf(int a, int b) {
			if (a > b)
				return 1;
			else if (a < b)
				return -1;
			else
				return 0;
		}

		public string TestSwitch (string nombre) {

			switch(nombre) {
					case "Jos": 
						Console.WriteLine("Hola Jos. Buenos das");
						break;
					case "Paco": 
						Console.WriteLine("Hola Paco. Me alegro de verte");
						break;
					default: 
						Console.WriteLine("Hola {0}", nombre); 
						break;
				}

			return "ok";
		}

		static int TestGoto(string label) {
			int result;

			switch(label) {
				case null:
					goto case "runner-up";
				case "fastest":
				case "winner":
					result = 1; break;
				case "runner-up":
					result = 2; break;
				default:
					result = 0;
					break;
			}
			return result;
		}

		public int TestWhile (int n) {

			int i = 0;
			int sum = 0;

			while (i < n) {
				sum += i;
				i++;
			}

			return sum;
		}

		public int TestDoWhile (int n) {

			int i = 0;
			int sum = 0;

			do {
				sum += i;
				i++;
			} while ((sum<10000) && (i<n));

			return sum;
		}

		public int TestFor (int n) {

			int sum = 0;

			for (int i=0; i<n; i++)
				sum += i;

			return sum;
		}

		public int TestNestedFor (int n) {

			int sum = 0;

			for (int i=0; i<n; i++)
				for (int j=0; j<n; j++)
                    sum += i*j;

			return sum;
		}


		public void TestException () {
			try {  
				Console.WriteLine("try");
				throw new Exception("message");
			} 
			catch (ArgumentNullException e) {
				Console.WriteLine("Null argument");
			} 
			catch {
				Console.WriteLine("catch");
			} 
			finally {
				Console.WriteLine("finally");
			}

		}


		public static void TestForeach(string[] args) {
			foreach (string s in args) 
				Console.WriteLine(s);
		}

		public static int TestRecursion (int n) {

			if (n>1)
			    return n * TestRecursion(n-1);
			else
				return 1;
		}


		public static void TestLocalVariables () {

			int x = TestRecursion(5);

			if (x>10) {

				int dif = x-10;

				Console.WriteLine(dif);
			}
		}
	}

	public class TestClass {
		
		// Constants
		public const string constant = "1.0.0";
		
		// Fields
		public static readonly double static_field = Math.Sin(Math.PI);
		public readonly string readonly_field;

		// Constructor
		public TestClass(string s) {
			readonly_field = s; 
		}  


		// Properties
		private string caption;

		public string Caption {
			get { return caption; }
			set { caption = value; }
		}

		//Indexers
		private string[] array;

		public string this[int x] {
			get { 
				return array[x];
			}
			set { 
				array[x] = value; 
			}
		}

		// Operator overloading

		public static bool operator == (TestClass obj1, TestClass obj2) {
			return (obj1.readonly_field == obj2.readonly_field);
		}

		public static bool operator != (TestClass obj1, TestClass obj2) {
			return (obj1.readonly_field != obj2.readonly_field);
		}


	}

	// Atributos

	[AttributeUsage(AttributeTargets.All)]
	public class TestAttribute: Attribute {
		public string Topic = null;
		private string url;

		public TestAttribute(string url) {
			this.url = url;
		}
		public string Url { 
			get { return url; }
		}
		public override string ToString() { 
			string s1 = "     Url = " +  this.Url;
			string dev = (this.Topic != null) ?
				(s1 + " - Topic: " + this.Topic) : s1;
			return (dev); 
		}
	} 

	[Test("http://csharp.ikor.org/attributes.html", Topic="Attributes")]
	class TestAttributeUsage {
		/* Blah, blah, blah... */
	} 
 





	struct TestStruct {
		int x, y;

		public TestStruct(int x, int y) {
			this.x = x; 
			this.y = y;
		}
		public int X { 
			get { return x; }
			set { x = value; } 
		}
		public int Y { 
			get { return y; }
			set { y = value; } 
		}
	}

	
	class TestDelegate {
	
		/// <summary>
		/// Delegate
		/// </summary>
		delegate double Del (double x);   

		/// <summary>
		/// Standard function
		/// </summary>
		/// <param name="x"></param>
		/// <returns></returns>

		static double incremento (double x) { 
			return (++x); 
		}

		/// <summary>
		/// Delegate instantiation
		/// </summary>
		/// <param name="args">None</param>

		static void Main(string[] args) {
		 
			Del del1 = new Del (Math.Sin);  
			Del del2 = new Del (Math.Cos);  
			Del del3 = new Del (incremento);  
  	
			Console.WriteLine (del1(0));  //  0
			Console.WriteLine (del2(0));  //  1
			Console.WriteLine (del3(10)); // 11

			Console.ReadLine();
		}
	}



}
